#
# gconst.rb
#
#     Copyright(c) 1999 Minero Aoki
#     aamine@dp.u-netsurf.ne.jp
#
# usage:
#
#   global_const '$GLOBAL_VAR', val
#     :
#   $GLOBAL_VAR = str   #--> NameError!
#

require 'amstd/must'


def global_const( name, val )
  case name
  when String
    nstr = name
    nid = name.intern
  when Integer
    nstr = name.id2name
    nid = name
  else
    name.must String, Integer
  end

  unless /\A\$[A-Z]\w*\z/o === nstr then
    raise ArgumentError,
      "wrong name for global constant '#{nstr}'"
  end

  if eval nstr then
    raise NameError,
      "variable #{name} is already initialized"
  end


  temp = val
  eval "#{nstr} = temp"
  trace_var( nid ) do
    raise NameError,
      "already initialized global constant #{nstr}"
  end
end


if $0 == __FILE__ then
  global_const '$E', 'this is $E'      # set new global constant
  puts $E
  begin
    $E = 'wrong value for $E'          # name error
  rescue
    puts $!
  end
  
  begin
    global_const '$A a', 'wrong name'  # wrong name
  rescue
    puts $!
  end
end
