#
# readrc.rb
#
#   mailest resource parser
#
#   Copyright(c) 1999 Minero Aoki
#   aamine@dp.u-netsurf.ne.jp
#

class ESTrcp

  def parse( fname )
    @fname = fname
    unless File.exist? fname then
      puts "config file '#{fname}' not exist"
      exit 1
    end
    ret = nil

    File.open( fname ) do |f|
      ret = parse_conffile( f )
#puts ret.type
    end
#puts ret.type

    return ret
  end


  private


  def parse_conffile( f )
    @lineno = 0
    return parse_block( f, true )
  end


  def parse_block( f, toplevel = false )
    hash = {}

    f.each do |line|
#puts line
      @lineno += 1

      if /\#/o === line then
        line = $`
      end
      line.strip!

      case line
      when /([\w\-]+)\s+\"([\w\- ]+)\"\s*\{\z/o    # data block
#puts 'begin block'
        entry = $1
        name = $2

        unless ret = hash[ entry ] then
          hash[ entry ] = ret = {}
        end

        if ret[ name ] then
          configerror! "entry '#{name}' exist twice"
        end
        ret[ name ] = parse_block( f )

      when /([\w\-]+)\s*\{\z/o                # config block
#puts 'begin global block'
        entry = $1
        if hash[ name ] then
          configerror! "entry '#{name}' exist twice"
        end
        hash[ entry ] = parse_block( f )

      when /\}\z/o                        # end block
#puts 'end block'
#puts hash.type
        return hash
      
      when ''                             # void line
#puts 'void line'
        ;
      
      else                                # rc entry
#puts 'value line'
        key, val = line.split(/[=:]/o, 2)
        key.strip!
        val.strip!

        hash[ key ] = val
      end
    end

    unless toplevel then
      configerror! "number of '{' is more than the one of '}'"
    end
    return hash
  end


  class ConfigError < Exception ; end

  def configerror!( mes )
    raise ConfigError,
      "error in config file #{@fname}(line #{@lineno}): " + mes
  end

end
